<?php


# check if session is valid
$newTarget = '/app/berogui/index.php?m=RebootReset';
include('/usr/local/www/berogui/includes/session.php');
unset($newTarget);

/**
 * @file
 * Factory Reset, Datenbank löschen und neu erzeugen
 */
chdir('../..');

include('./includes/variables.php');
include('./misc/database.php');
include('/usr/fallback/beroConf.php');

require_once('./modules/PstnHardware/PstnHardware.php');

$inserts=array();
// keep sip-settings
if (isset($_POST['keep_sip_set'])){
	$ba = new beroAri();
	$q = $ba->select('SELECT * FROM sip;');

	while ($entry=sqlite_fetch_array($q, SQLITE_ASSOC)){
		unset($fields);
		unset($values);
		foreach ($entry as $key => $val){
			$fields .= ((strlen($fields) == 0) ? '' : ',') . $key;
			$values .= ((strlen($values) == 0) ? '' : ',') . '\'' . sqlite_escape_string($val) . '\'';
		}
		$inserts[] = 'INSERT INTO sip (' . $fields . ') VALUES (' . $values . ');';
	}
}

// keep cloud-settings
if (isset($_POST['keep_cloud_set'])){
	$ba = new beroAri();
	$nameArray = array('proxyEnabled', 'proxyAddress', 'proxyPort', 'proxyType', 'proxyUser', 'proxySecret', 'cloudAddress');
	foreach ($nameArray as $name) {
		$cloudSettings[$name]=$ba->get($name);
	}
}
// keep prefix-settings
if (isset($_POST['keep_prefix_set'])){
	$ba = new beroAri();
	$nameArray = array('national_code', 'international_code');
	foreach ($nameArray as $name) {
		$prefixSettings[$name]=$ba->get($name);
	}
}
//keep ACL Settings 
if (isset($_POST['keep_set'])) {
	$ba = new beroAri();
	$q = $ba->select('SELECT * FROM acl;');

	while ($entry=sqlite_fetch_array($q, SQLITE_ASSOC)){
		unset($fields);
		unset($values);
		foreach ($entry as $key => $val){
			$fields .= ((strlen($fields) == 0) ? '' : ',') . $key;
			$values .= ((strlen($values) == 0) ? '' : ',') . '\'' . sqlite_escape_string($val) . '\'';
		}
		$inserts[] = 'INSERT INTO acl (' . $fields . ') VALUES (' . $values . ');';
	}
}

// delete database ari.db
exec('/bin/rm /usr/conf/ari.db');

//delete voip-wizard.conf
//exec('/bin/rm /usr/conf/voip-wizard.conf');

//Create new db
$ba = new beroAri();

if ($ba->is_error()){
	echo '<script>alert("' . $ba->error() .'");</script>';
}

// reset rootdb
$bc = new beroConf('root');
$bc->exec_sql("DELETE FROM root WHERE key NOT IN ('root-version', 'lan-mtu', 'lan-iface', 'lan-ipaddr', 'lan-netmask', 'lan-gateway', 'lan-dhcp', 'lan-mode', "
	. "'lan-ports', 'msp-iface', 'msp-ipaddr', 'app-image', 'app-status', 'ntphost', 'cloud_enable', 'cloud_key', 'lan-nameserver', 'vlan-enable', 'vlan-id', "
	. "'vlan-prio', 'wan-dhcp', 'wan-ipaddr', 'wan-netmask', 'wan-gateway', 'bonding-mode', 'bonding-miimon', 'bonding-updelay', 'bonding-downdelay');");

//keep network settings
if (!isset($_POST['keep_set'])) {

	$delArray = array('lan-ipaddr', 'lan-netmask', 'lan-gateway', 'lan-nameserver', 'ntphost', 'vlan-enable', 'vlan-id', 
		'vlan-prio', 'lan-mode', 'wan-dhcp', 'wan-ipaddr', 'wan-netmask', 'wan-gateway', 'bonding-mode', 'bonding-miimon', 
		'bonding-updelay', 'bonding-downdelay');
	foreach ($delArray as $delItem) {
		$bc->delete('root', $delItem);
	}
	unset($delArray);

	$bc->set('root', 'lan-iface', 'eth0');
	$bc->set('root', 'lan-dhcp', 'yes');
	$bc->set('root', 'lan-mtu', '1500');
	$bc->set('root', 'beroAvahi-enabled', '1');
}

// set a default ntphost (if none is set, but configuration is static)
if ($bc->get('root', 'lan-dhcp') != 'yes') {
	if (strlen($bc->get('root', 'ntphost')) == 0) {
		$bc->set('root', 'ntphost', 'ntp0.fau.de');
	}
}
if (!isset($_POST['keep_cloud_set'])){
	$bc->exec_sql("DELETE FROM root WHERE key IN ('cloud_enable', 'cloud_key');");
}
//restore apps
if (!isset($_POST['keep_app_set'])){

	exec('/bin/mount -o remount,rw /home/admin/');

	if ($handle = opendir('/home/admin/apps/')) {
		while (false !== ($file = readdir($handle))) {
			if (($file == '.') || ($file == '..')) {
				continue;
			}
			exec('/bin/rm -rf /home/admin/apps/' . $file);
			exec('/bin/rm -rf /home/admin/www/' . $file);
		}
		closedir($handle);
	}

	exec('/bin/rm -rf /usr/conf/userapp');
	exec('sync');
	exec('/bin/mount -o remount,ro /home/admin/');
}

$bc->set('root', 'msp-iface', 'eth1');
$bc->set('root', 'msp-ipaddr', 'auto');
$bc->set('root', 'app-status', 'running');
$bc->set('root', 'userapp-enabled', '1');

// restore settings
foreach ($inserts as $sql) {
	$ba->insert_($sql);
}

// restore cloud-settings
if (isset($_POST['keep_cloud_set'])) {
	foreach ($cloudSettings as $key => $value) {
		$ba->set($key, sqlite_escape_string($value));
	}
}
// restore prefix-settings
if (isset($_POST['keep_prefix_set'])) {
	foreach ($prefixSettings as $key => $value) {
		$ba->set($key, sqlite_escape_string($value));
	}
}

// if E1/T1 module is plugged, we activate the module depending the choice made before to make the factory-reset
// Copy / Past only the useful steps from PstnHardware class
if (isset($_POST['set_hw']) && isset($_POST['id_upd'])) {

        $database = new beroAri();

        $pstn_hw = new PstnHardware();

        $database -> set('pcm_server_port', '');

        // Country Setting
        $database -> set('country', '');

        $database -> set('ohs', '0');
        $database -> set('ohs2', '0');

        $database -> set('rt', '0');
        $database -> set('rt2', '0');

        $database -> set('rz', '0');
        $database -> set('dcv', '0x0');
        $database -> set('mini', '0x0');
        $database -> set('acim', '0x0');
        $database -> set('ilim', '0');

        $database -> set('boostringer', '0');

        // ISDN clock
        $pstn_hw -> clock($ba, 'isdn');

        // CAS clock
        $pstn_hw -> clock($ba, 'cas');

        $id = $_POST['id_upd'];
        $type_array = $_POST['type'];

        $update_cas_channels = false;
        $update_isdn_channels = false;
        for ($i = 0; $i < count($id); $i++) {
                $id_upd = $id[$i];
                $type = $type_array[$i];

                if ($type == "cas") {

                        $termination = $_POST["casmode" . $id_upd];
                        if ($termination == "") {
                                $termination = "te";
                        }

                        $coding = $_POST["coding" . $id_upd];
                        $query_upd = $database -> update("UPDATE cas SET termination='" . sqlite_escape_string($termination) . "', coding='" . sqlite_escape_string($coding) . "' WHERE port='" . sqlite_escape_string($id_upd) . "'");
                }

                if ($type == "cashw") {

                        $t1e1 = $_POST["t1e1" . $id_upd];
                        if ($t1e1 == 1) {
                                $protocol = "t1";
                        } else {
                                $protocol = "e1";
                        }
                        $interface_type = $_POST["interface_type" . $id_upd];

                        $query = $database -> select("select port_type from cas where port='" . sqlite_escape_string($id_upd) . "'");
                        $old_interface_type = sqlite_fetch_single($query);
                        if ($old_interface_type != $interface_type) {
                                $update_isdn = true;
                        }

                        $query = $database -> select("select protocol from cas where port='" . sqlite_escape_string($id_upd) . "'");
                        $old_protocol = sqlite_fetch_single($query);
                        if ($old_protocol != $protocol) {
                                $update_cas_channels = true;
                        }

                        $query_upd = $database -> update("UPDATE cas SET protocol='" . sqlite_escape_string($protocol) . "', port_type='" . sqlite_escape_string($interface_type) . "' WHERE port='" . sqlite_escape_string($id_upd) . "'");

                        $ba -> set('set_hw', 1);
                }
        }

        if ($update_cas_channels == true || $update_isdn == true) {

                $query_del = $database->delete("delete from isdn where ccs=1");
                $query_del = $database->delete("delete from cas_channels");

                $query = $database -> select("select port, type, port_type, protocol, lif from cas order by port");
                while ($entry = $database -> fetch_array($query)) {

                        if ($entry['protocol'] == 't1' && $entry['port_type'] == 'cas') {
                                for ($j = 0; $j < 24; $j++) {
                                        $database -> insert_("INSERT INTO cas_channels (port) VALUES('" . $entry['port'] . "');");
                                }
                        }

                        if ($entry['protocol'] == 'e1' && $entry['port_type'] == 'cas') {
                                for ($j = 0; $j < 31; $j++) {
                                        $database -> insert_("INSERT INTO cas_channels (port) VALUES('" . $entry['port'] . "');");
                                        if ($j == 15) {
                                                  $channel = $database -> rowid();
                                        }
                                }

                                $database->delete("delete from cas_channels where channel='" . $channel . "';");
                        }

                        if ($entry['port_type'] == 'hdlc') {
                                $pstn_hw -> regroupIsdn($ba, $entry);
                        }
                }

                $pstn_hw -> regroupIsdn($ba);
        }

        $database -> set('master', 'all');
        $database -> set('activate', '3');
}

// doesn't this belong into 'create_files.php'??
// reset api-password
@unlink('/usr/conf/apiusers.conf');
require_once('/usr/local/php/include/apiusers.Class.php');
$apiusers=new apiusers('admin');
$apiusers->createFile();

// reset password for user admin and deactivate account
exec('/usr/local/sbin/pwchange.sh admin admin');
exec('/bin/mount -oremount,rw /; /usr/bin/passwd -l admin; sync; /bin/mount -oremount,ro /');

echo '<script>window.location.href="' . (($_POST['v'] == 'Wizard') ? '../../index.php?m=Wizard' : '../../includes/create_files.php') . '"</script>';

?>
